<?php

class SprStatusMod extends DbMod{
  var $VarTableSprStatusTypes = array('integer', 'text', 'text', 'integer');
  
  function SprStatusMod($ArrMsSp){
		parent::__construct($ArrMsSp);
		return true;
	}

	function GetFromDb($VarSqlName = 'SqlAll', $VarSqlGet = 'GetAll', $VarWhere = '', $VarOrder = '', $VarLimit = ''){
    /*** begin default values ***/
    $ArrSqlArray['SqlAll']['select'] = 'a.*';
    $ArrSqlArray['SqlAll']['from'] = $this->VarTableSprStatus .' AS a';
    if('' != $VarWhere){
      $ArrSqlArray['SqlAll']['where'] = $VarWhere;
    }
    if('' != $VarOrder){
      $ArrSqlArray['SqlAll']['order'] = $VarOrder;
    }
    if('' != $VarLimit){
      $ArrSqlArray['SqlAll']['limit'] = $VarLimit;
    }
    /*** end default values ***/
    ///
    $ArrSqlArray['SqlCount']['select'] = 'count(*) AS vartotal';
    $ArrSqlArray['SqlCount']['from'] = $this->VarTableSprStatus .' AS a';
    if('' != $VarWhere){
      $ArrSqlArray['SqlCount']['where'] = $VarWhere;
    }
    ///
    $ArrSqlArray['SqlWriteoffAll']['select'] = 'a.*, count(b._id) AS svt_count';
    $ArrSqlArray['SqlWriteoffAll']['from'] = $this->VarTableSprStatus .' AS a';
    $ArrSqlArray['SqlWriteoffAll']['leftjoin'] = $this->VarTableSvt .' AS b ON a.sprstatus_id = b.sprstatus_id AND YEAR(b.svt_date) < YEAR(NOW())-a.sprstatus_writeoff+1';
    if('' != $VarWhere){
      $ArrSqlArray['SqlWriteoffAll']['where'] = $VarWhere;
    }
    $ArrSqlArray['SqlWriteoffAll']['group'] = 'a.sprstatus_id';
    if('' != $VarOrder){
      $ArrSqlArray['SqlWriteoffAll']['order'] = $VarOrder;
    }
    if('' != $VarLimit){
      $ArrSqlArray['SqlWriteoffAll']['limit'] = $VarLimit;
    }
    ///
    $ArrResult = $this->DbGet($ArrSqlArray[$VarSqlName], $VarSqlGet);
  	return $ArrResult;
	}

  function Add($values){
    if(true === is_array($values) && 1 <= count($values)){
      $VarSql = 'INSERT INTO '. $this->VarTableSprStatus .'
                (sprstatus_id, sprstatus_name, sprstatus_color, sprstatus_order)
                VALUES (?, ?, ?, ?)';
      $values = $this->PrepareData($values);
      $ArrData = array(
        '',
        $values['sprstatus_name'],
        $values['sprstatus_color'],
        $values['sprstatus_order']
      );
      //SiteLibs::GetVarDump($data);
      $sth = $this->ArrMsSp->SP_DbConnect->prepare($VarSql, $this->VarTableSprStatusTypes, MDB2_PREPARE_MANIP);
      $VarQueryResult = $sth->execute($ArrData);
      if(PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      $VarId = $this->ArrMsSp->SP_DbConnect->lastInsertID($this->VarTableSprStatus, 'sprstatus_id');
      if (PEAR::isError($VarId)) {
        return array('error' => $VarId->getMessage());
      }
      return $VarId;
    }
    else{
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
  }

  function Edit($values){
    if(true === is_array($values) && 1 <= count($values)){
      $VarSql = "UPDATE ". $this->VarTableSprStatus ." SET
                  sprstatus_name = ?,
                  sprstatus_color = ?,
                  sprstatus_order = ?
                  WHERE sprstatus_id = '".  $values['sprstatus_id'] ."'";
      $values = $this->PrepareData($values);
      $ArrData = array(
        $values['sprstatus_name'],
        $values['sprstatus_color'],
        $values['sprstatus_order']
      );
      $sth = $this->ArrMsSp->SP_DbConnect->prepare($VarSql);
      $VarQueryResult = $sth->execute($ArrData);
      if(PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      return $values['sprstatus_id'];
    }
    else{
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
  }

  function Del($VarId = '', $VarFiledName = 'sprstatus_id'){
    if('' != $VarId && true === is_numeric($VarId)){
      $sql = "DELETE FROM ". $this->VarTableSprStatus ." WHERE ". $VarFiledName ." = '". $VarId ."'";
      //echo "sql: ". $sql ."<br />";
      $VarQueryResult = $this->ArrMsSp->SP_DbConnect->exec($sql);
      if (PEAR::isError($VarQueryResult)) {
        return array('error' => $VarQueryResult->getMessage());
      }
      return true;
    }
    else {
      return array('error' => $this->ArrMsSp->Sp_LangMessage['error']['ErrSettingWrong']);
    }
	}
  
  function PrepareData($values){
    if(true === is_array($values) && 1 <= count($values)){
      $values['sprstatus_name'] = SiteLibs::ConvertTextToSql($values['sprstatus_name']);
      $values['sprstatus_color'] = SiteLibs::ConvertTextToSql($values['sprstatus_color']);
      $values['sprstatus_order'] = SiteLibs::ConvertSqlIntegerInsert($values['sprstatus_order']);
    }
    return $values;
  }
}
?>